"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MultiMatchMediaQuery = require("./MultiMatchMediaQuery");

var Device = function () {
    function Device(name, group, width, height, matchListener) {
        _classCallCheck(this, Device);

        this.name = name;
        this.group = group;
        this.width = width;
        this.height = height;

        this.portraitMediaQuery = this.createPortraitMediaQuery();
        this.landscapeMediaQuery = this.createLandscapeMediaQuery();

        this.addMatchListener(matchListener);

        this.getMatch = this.getMatch.bind(this);
        this.addMatchListener = this.addMatchListener.bind(this);
        this.removeMatchListener = this.removeMatchListener.bind(this);
    }

    _createClass(Device, [{
        key: "addMatchListener",
        value: function addMatchListener(listener) {
            if (listener) {
                this.portraitMediaQuery.addListener(listener);
                this.landscapeMediaQuery.addListener(listener);
            }
        }
    }, {
        key: "removeMatchListener",
        value: function removeMatchListener(listener) {
            this.portraitMediaQuery.removeListener(listener);
            this.landscapeMediaQuery.removeListener(listener);
        }
    }, {
        key: "createPortraitMediaQuery",
        value: function createPortraitMediaQuery() {
            var mediaQueries = [];
            mediaQueries.push(window.matchMedia("(width: " + this.width + "px)"));
            mediaQueries.push(window.matchMedia("(height: " + this.height + "px)"));
            return new MultiMatchMediaQuery(this.name, mediaQueries);
        }
    }, {
        key: "createLandscapeMediaQuery",
        value: function createLandscapeMediaQuery() {
            var mediaQueries = [];
            mediaQueries.push(window.matchMedia("(height: " + this.width + "px)"));
            mediaQueries.push(window.matchMedia("(width: " + this.height + "px)"));
            return new MultiMatchMediaQuery(this.name + 'Landscape', mediaQueries);
        }
    }, {
        key: "getMatch",
        value: function getMatch() {
            if (this.portraitMediaQuery.isMatched()) {
                return { group: this.group, name: this.portraitMediaQuery.name };
            } else if (this.landscapeMediaQuery.isMatched()) {
                return { group: this.group, name: this.landscapeMediaQuery.name };
            }
            return false;
        }
    }]);

    return Device;
}();

module.exports = Device;