"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MultiMatchMediaQuery = require("./MultiMatchMediaQuery");

var DeviceGroup = function () {
    function DeviceGroup(name, sizes) {
        _classCallCheck(this, DeviceGroup);

        this.name = name;
        this.minWidth = sizes.minWidth;
        this.minHeight = sizes.minHeight;
        this.maxWidth = sizes.maxWidth;
        this.maxHeight = sizes.maxHeight;
        this.mediaQuery = this.createMediaQuery();

        this.isMatched = this.isMatched.bind(this);
        this.addMatchListener = this.addMatchListener.bind(this);
        this.removeMatchListener = this.removeMatchListener.bind(this);
    }

    _createClass(DeviceGroup, [{
        key: "addMatchListener",
        value: function addMatchListener(listener) {
            this.mediaQuery.addListener(listener);
        }
    }, {
        key: "removeMatchListener",
        value: function removeMatchListener(listener) {
            this.mediaQuery.removeListener(listener);
        }
    }, {
        key: "createMediaQuery",
        value: function createMediaQuery() {
            var mediaQueries = [];
            if (this.minWidth) {
                mediaQueries.push(window.matchMedia("(min-width: " + this.minWidth + "px)"));
            }
            if (this.minHeight) {
                mediaQueries.push(window.matchMedia("(min-height: " + this.minHeight + "px)"));
            }
            if (this.maxWidth) {
                mediaQueries.push(window.matchMedia("(max-width: " + this.maxWidth + "px)"));
            }
            if (this.maxHeight) {
                mediaQueries.push(window.matchMedia("(max-height: " + this.maxHeight + "px)"));
            }
            return new MultiMatchMediaQuery(this.name, mediaQueries);
        }
    }, {
        key: "isMatched",
        value: function isMatched() {
            return this.mediaQuery.isMatched();
        }
    }]);

    return DeviceGroup;
}();

module.exports = DeviceGroup;