"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MultiMatchMediaQuery = function () {
    function MultiMatchMediaQuery(name, mediaQueries) {
        var _this = this;

        _classCallCheck(this, MultiMatchMediaQuery);

        this.name = name;
        this.mediaQueries = mediaQueries;
        this.listeners = [];

        this.isMatched = this.isMatched.bind(this);
        this.addListener = this.addListener.bind(this);
        this.removeListener = this.removeListener.bind(this);
        this.handleMediaChange = this.handleMediaChange.bind(this);

        this.matches = this.isMatched();
        this.mediaQueries.forEach(function (query) {
            return query.addListener(_this.handleMediaChange);
        });
    }

    _createClass(MultiMatchMediaQuery, [{
        key: "isMatched",
        value: function isMatched() {
            return this.mediaQueries.every(function (query) {
                return query.matches;
            });
        }
    }, {
        key: "addListener",
        value: function addListener(listener) {
            if (listener) {
                this.listeners.push(listener);
            }
        }
    }, {
        key: "removeListener",
        value: function removeListener(remove) {
            this.listeners = this.listeners.filter(function (listener) {
                return listener !== remove;
            });
        }
    }, {
        key: "handleMediaChange",
        value: function handleMediaChange() {
            var _this2 = this;

            var old = this.matches;
            this.matches = this.isMatched();
            if (old !== this.matches) {
                this.listeners.forEach(function (callback) {
                    return callback(_this2);
                });
            }
        }
    }]);

    return MultiMatchMediaQuery;
}();

module.exports = MultiMatchMediaQuery;