"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ReactiveMedia = function () {
    function ReactiveMedia(devices, groups) {
        var _this = this;

        _classCallCheck(this, ReactiveMedia);

        this.devices = devices;
        this.groups = groups;
        this.mediaChangeListeners = [];
        this.getMatchedMedia = this.getMatchedMedia.bind(this);
        this.onMediaQueryChange = this.onMediaQueryChange.bind(this);
        this.addMediaChangeListener = this.addMediaChangeListener.bind(this);
        this.removeMediaChangeListener = this.removeMediaChangeListener.bind(this);
        this.devices.forEach(function (device) {
            return device.addMatchListener(_this.onMediaQueryChange);
        });
        this.groups.forEach(function (group) {
            return group.addMatchListener(_this.onMediaQueryChange);
        });
    }

    _createClass(ReactiveMedia, [{
        key: "addMediaChangeListener",
        value: function addMediaChangeListener(listener) {
            this.mediaChangeListeners.push(listener);
        }
    }, {
        key: "removeMediaChangeListener",
        value: function removeMediaChangeListener(remove) {
            this.mediaChangeListeners = this.mediaChangeListeners.filter(function (listener) {
                return listener !== remove;
            });
        }
    }, {
        key: "onMediaQueryChange",
        value: function onMediaQueryChange() {
            var _this2 = this;

            var newMedia = this.getMatchedMedia();
            if (newMedia && newMedia !== this.matchedMedia) {
                this.matchedMedia = newMedia;
                this.mediaChangeListeners.forEach(function (listener) {
                    return listener.handleMediaChange(_this2.matchedMedia);
                });
            }
        }
    }, {
        key: "getMatchedMedia",
        value: function getMatchedMedia() {
            var matchedDevices = this.devices.filter(function (device) {
                return !!device.getMatch();
            });
            var matches = matchedDevices && matchedDevices.length > 0 ? matchedDevices.map(function (device) {
                return device.getMatch();
            }) : [];
            var group = this.groups.find(function (group) {
                return group.isMatched();
            });
            return { group: group, matches: matches };
        }
    }, {
        key: "addDevice",
        value: function addDevice(device) {
            this.devices.push(device);
        }
    }, {
        key: "removeDevice",
        value: function removeDevice(remove) {
            this.devices = this.devices.filter(function (device) {
                return device !== remove;
            });
        }
    }, {
        key: "addGroup",
        value: function addGroup(group) {
            this.groups.push(group);
        }
    }, {
        key: "removeGroup",
        value: function removeGroup(remove) {
            this.groups = this.groups.filter(function (group) {
                return group !== remove;
            });
        }
    }]);

    return ReactiveMedia;
}();

module.exports = ReactiveMedia;