'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var assign = require('deep-assign');

var StyleSheet = function () {
    function StyleSheet(styles) {
        _classCallCheck(this, StyleSheet);

        this.styles = styles;
    }

    _createClass(StyleSheet, [{
        key: 'getStyles',
        value: function getStyles(media) {
            var styles = JSON.parse(JSON.stringify(this.styles));
            var defaultStyles = styles.default;

            // Find the first matched device for which there is a defined style
            var device = false;
            if (media.matches) {
                device = media.matches.find(function (device) {
                    var styleGroup = styles[device.group.name];
                    return styleGroup ? styleGroup[device.name] : false;
                });
            }

            if (device) {
                // if a matched devices has defined styles return those styles (combined with any missing defaults)
                var deviceStyles = styles[device.group.name][device.name];
                var defaultGroupStyles = styles[device.group.name].default;
                return assign({}, defaultStyles, defaultGroupStyles, deviceStyles);
            } else if (media.group && styles[media.group.name]) {
                // if no devices match or styles are not defined, return default styles for group
                return assign({}, defaultStyles, styles[media.group.name].default);
            }
            // if both group and device is not matched or styles are undefined return default styles
            return defaultStyles;
        }
    }]);

    return StyleSheet;
}();

module.exports = StyleSheet;